#define	LCD_RS			LATDbits.LATD0
#define	LCD_RW			LATDbits.LATD1
#define	LCD_E			LATDbits.LATD2
#define	LCD_CS			LATDbits.LATD3
#define	LCD_RST			LATDbits.LATD7

#define	LCD_RS_TRIS		TRISDbits.TRISD0
#define	LCD_RW_TRIS		TRISDbits.TRISD1
#define	LCD_E_TRIS		TRISDbits.TRISD2
#define	LCD_CS_TRIS		TRISDbits.TRISD3
#define	LCD_RST_TRIS	TRISDbits.TRISD7

#define	LCD_DATA_DIR	TRISB
#define	LCD_DATA_OUT	LATB
#define	LCD_DATA_IN		PORTB

#define	LCD_CMD_MODE			0x00
#define LCD_CMD_CHAR_PITCH		0x01
#define LCD_CMD_NUM_CHARS		0x02
#define LCD_CMD_TIME_DIVISION		0x03
#define LCD_CMD_CURSOR_POS		0x04

#define LCD_CMD_DISPLAY_START_LA	0x08
#define LCD_CMD_DISPLAY_START_HA	0x09
#define LCD_CMD_CURSOR_LA		0x0A
#define LCD_CMD_CURSOR_HA		0x0B

#define LCD_CMD_WRITE_DATA		0x0C
#define LCD_CMD_READ_DATA		0x0D

#define LCD_CMD_CLEAR_BIT		0x0E
#define LCD_CMD_SET_BIT			0x0F

/* Bits of the LCD Mode Control Register (DB5-DB0) */
#define LCD_MODE_ON_OFF		32
#define LCD_MODE_MASTER_SLAVE	16
#define LCD_MODE_BLINK		8
#define LCD_MODE_CURSOR		4
#define LCD_MODE_MODE		2
#define LCD_MODE_EXTERNAL	1

/* Possible settings of the character pitch register */
/* Horizontal character pitches of 6, 7, and 8 */
#define LCD_CHAR_PITCH_HP_6	0x05
#define LCD_CHAR_PITCH_HP_7	0x06
#define LCD_CHAR_PITCH_HP_8	0x07

/* To indicate the state of a pixel */
#define PIXEL_ON	0xFF
#define PIXEL_OFF	0x00

#define LCD_WIDTH	160
#define	LCD_HEIGHT	80

/* Low-level LCD interface functions */
void lcd_strobe_enable(void);
void lcd_write_command(unsigned char command, unsigned char data);
void lcd_wait_busy(void);

/* LCD Graphics interface */
void lcd_graphics_init(void);
void lcd_graphics_clear(void);
void lcd_graphics_move(unsigned int x, unsigned int y);
void lcd_graphics_draw_byte(unsigned char data);
void lcd_graphics_plot_byte(unsigned int x, unsigned int y, unsigned char data);
void lcd_graphics_plot_pixel(unsigned int x, unsigned int y, unsigned char state); 
void lcd_test_clear(void);




